/*********************************************************************
*                    SEGGER Microcontroller GmbH                     *
*                        The Embedded Experts                        *
**********************************************************************

-------------------------- END-OF-HEADER -----------------------------

File    : main.c
Purpose : Generic application start

*/

#include <stdio.h>
#include <stdlib.h>

typedef unsigned long  U32;
typedef unsigned short U16;
typedef unsigned char  U8;

typedef enum {
  enumVal1 = 1,
  enumVal2 = 2,
  enumVal3 = 3
} Enumerator_t;

typedef struct {
  U32 Bit1  : 1;
  U32 Bit2  : 2;
  U32 Bit3  : 3;
  U32 Bit4  : 4;
  U32 Bit6  : 6;
  U32 Bit16 : 16;
} BitField_t;

typedef union {
  U32        Word;
  BitField_t Bits;
} Converter_t;

typedef struct {
  U32         Word;
  U16         Halfword;
  U8          Byte;
  Converter_t Converter;
} Struture_t;

volatile BitField_t   _BitField;
volatile Converter_t  _Converter;
volatile Struture_t   _Structure;
volatile Enumerator_t _Enumerator;

/*********************************************************************
*
*       main()
*
*  Function description
*   Application entry point.
*/
int main(void) {
  int i;

  _BitField.Bit1  =  1;
  _BitField.Bit2  =  2;
  _BitField.Bit3  =  4;
  _BitField.Bit4  =  8;
  _BitField.Bit6  = 32;
  _BitField.Bit16 = 32768;

  _Enumerator = enumVal1;
  _Enumerator = enumVal2;
  _Enumerator = enumVal3;

  _Converter.Word = 0x12341111;

  _Structure.Byte           = 0x42;
  _Structure.Halfword       = 0x43;
  _Structure.Word           = 0x44;
  _Structure.Converter.Word = 0x45;


  for (i = 0; i < 100; i++) {
    printf("Hello World %d!\n", i);
  }
  do {
    i++;
  } while (1);
}

/*************************** End of file ****************************/
